
// File: <demo_framework.h>
// Copyright (c) 1997-2007, Reachin Technologies AB.
// All rights reserved.
// The copyright to the computer program herein is the property of Reachin
// Technologies AB, Sweden. The program may be used and/or copied only with the
// written permission of Reachin Technologies AB or in accordance with the terms
// stipulated in the agreement under which the program has been supplied.

#ifndef _DEMO_FRAMEWORK_H_
#define _DEMO_FRAMEWORK_H_

#include <windows.h>
#include "graphics_framework.h"

struct inputState_t
{
	bool	keyboardKey[256];
	int		mouseX;
	int		mouseY;
	bool	mouseButton[2];
};

class IDemoFramework
{
public:
	IDemoFramework()			{}
	virtual ~IDemoFramework()	{}

	virtual const char*		GetDemoName() = 0;													// this will be the window title text
	virtual bool			InitDemo(IGraphicsFramework* gfx, inputState_t* inputState) = 0;	// initialize the demo
	virtual void			ShutDownDemo() = 0;													// shutdown the demo
	virtual void			UpdateDemo(float deltaTime, int width, int height) = 0;				// called every frame, do demo logic and render calls here (deltaTime = time in sec since last frame)
};

#endif