
/** This file is based on the HaptX example kode
	Tetrahedral mesh viewer for HaptX
	using the HaptX demo framework
	Edited by Rolf Anders Syvertsen
	04.05.2007
	rolfans@stud.ntnu.no
	rolfans@gmail.com
*/

#ifndef NEEDLEINSERTION_H
#define NEEDLEINSERTION_H

#include "HaptX/graphics_framework.h"
#include "HaptX/demo_framework.h"

#include "tetmesh.h"

class NeedleInsertion : public IDemoFramework
{
private:
	IGraphicsFramework*		m_graphics;
	inputState_t*			m_input;
	IGraphicsRenderModel*	m_model;
	IGraphicsRenderModel*	m_proxyModel;
	IGraphicsRenderModel*	m_floor;
	IGraphicsRenderModel*	m_syringe;
	
	float					cx;
	float					cy;
	
	float					m_camSensitivity;
	bool					m_prevButton1;
	bool					m_prevButton2;

	int						m_activeNavigationModel;

	// the tetrahedral mesh
	TetMesh *m_ptetmesh;


private:
	void HandleMoveCamera(float deltaTime);
	void HandleCameraRotation(float x, float y);

public:
	NeedleInsertion();
	virtual ~NeedleInsertion();

	const char*		GetDemoName();
	// load the model
	bool			InitDemo(IGraphicsFramework* gfx, inputState_t* inputState);
	//! displaying the scene and a message
	void			LoadingFrame(std::string message);
	//! create the haptics shapes
	void			CreateHapticsShape();
	void			ShutDownDemo();
	void			UpdateDemo(float deltaTime, int width, int height);
};

#endif