/**	Made by Rolf Anders Syvertsen
*	2007
*	rolfans@gmail.com
*/

#include "tetrahedron.h"

Tetrahedron::Tetrahedron()
{
	m_vertex[0]=0;
	m_vertex[1]=0;
	m_vertex[2]=0;
	m_vertex[3]=0;
	m_faceNormal[0].setPoint(0.0,0.0,0.0);
	m_faceNormal[1].setPoint(0.0,0.0,0.0);
	m_faceNormal[2].setPoint(0.0,0.0,0.0);
	m_faceNormal[3].setPoint(0.0,0.0,0.0);
	m_type=0;

	m_pfaceNeighb1=0;
	m_pfaceNeighb2=0;
	m_pfaceNeighb3=0;
	m_pfaceNeighb4=0;

	m_renderface[0]=true;
	m_renderface[1]=true;
	m_renderface[2]=true;
	m_renderface[3]=true;
	m_neighbors=0;
}
Tetrahedron::~Tetrahedron()
{
}
void Tetrahedron::addCorners(int verti1, int verti2, int verti3, int verti4)
{
	m_vertex[0]=verti1;
	m_vertex[1]=verti2;
	m_vertex[2]=verti3;
	m_vertex[3]=verti4;
}
void Tetrahedron::setType(int type)
{
	m_type=type;
}
int Tetrahedron::getType()
{
	return m_type;
}
int *Tetrahedron::getVertex()
{
	return m_vertex;
}
void Tetrahedron::setFaceNorm(int ind,Vertex norm)
{
	if(ind>=0&&ind<4)
		m_faceNormal[ind]=norm;
//	else
		// error ....

}
Vertex Tetrahedron::getFaceNormAt(int index)
{
	// trenger en feil sjekk !!!
	return m_faceNormal[index];
}
void Tetrahedron::setNeighbor(int ind, Tetrahedron *tet)
{
	switch(ind)
	{
	case 0:
		m_pfaceNeighb1=tet;
		if(tet->getType()==m_type||(tet->getType()>=200&&tet->getType()<300))
			m_renderface[0]=false;
		break;
	case 1:
		m_pfaceNeighb2=tet;
		if(tet->getType()==m_type||(tet->getType()>=200&&tet->getType()<300))
			m_renderface[1]=false;
		break;
	case 2:
		m_pfaceNeighb3=tet;
		if(tet->getType()==m_type||(tet->getType()>=200&&tet->getType()<300))
			m_renderface[2]=false;
		break;
	case 3:
		m_pfaceNeighb4=tet;
		if(tet->getType()==m_type||(tet->getType()>=200&&tet->getType()<300))
			m_renderface[3]=false;
		break;
	}
	m_neighbors=0;
	if(m_renderface[0])
		m_neighbors++;
	if(m_renderface[1])
		m_neighbors++;
	if(m_renderface[2])
		m_neighbors++;
	if(m_renderface[3])
		m_neighbors++;
}
bool Tetrahedron::renderFaceAt(int ind)
{
//	if(ind>=0&&ind<4)
		return m_renderface[ind];
	//error ...
//	else
//		return false;
}
int Tetrahedron::numNeighbors()
{
	return m_neighbors;
}
