/**	Made by Rolf Anders Syvertsen
*	2007
*	rolfans@gmail.com
*/
#include "vertex.h"

Vertex::Vertex()
{
	m_vertex[0]=0.0;
	m_vertex[1]=0.0;
	m_vertex[2]=0.0;

	m_normal[0]=0.0;
	m_normal[1]=0.0;
	m_normal[2]=0.0;
}
void Vertex::setPoint(float x,float y, float z)
{
	m_vertex[0]=x;
	m_vertex[1]=y;
	m_vertex[2]=z;
}
float Vertex::getX()
{
	return m_vertex[0];
}
float Vertex::getY()
{
	return m_vertex[1];
}
float Vertex::getZ()
{
	return m_vertex[2];
}
void Vertex::setNormal(float x,float y, float z)
{
	m_normal[0]=x;
	m_normal[1]=y;
	m_normal[2]=z;
}
float Vertex::getNormalX()
{
	return m_normal[0];
}
float Vertex::getNormalY()
{
	return m_normal[1];
}
float Vertex::getNormalZ()
{
	return m_normal[2];
}
Vertex Vertex::cross(Vertex v2)
{	
	Vertex cro;
	cro.setPoint(m_vertex[1]*v2.getZ()-m_vertex[2]*v2.getY(), 
		m_vertex[2]*v2.getX()-m_vertex[0]*v2.getZ(),
		m_vertex[0]*v2.getY()-m_vertex[1]*v2.getX());

	return cro;
}
float Vertex::length()
{
	float leng=(float)sqrt(m_vertex[0]*m_vertex[0]+m_vertex[1]*m_vertex[1]+m_vertex[2]*m_vertex[2]);
	return leng;
}
Vertex Vertex::operator *(float scalar)
{
	Vertex v;
	v.setPoint(m_vertex[0]*scalar,
		m_vertex[1]*scalar,
		m_vertex[2]*scalar);
	return v;
}
