/**	Vertex data structure
	made by Rolf Anders Syvertsen
	2007-04-13
	rolfans@stud.ntnu.no
*/
#ifndef VERTEX_H
#define VERTEX_H

#include<math.h>
/** Also defines a 3d vector
*/
class Vertex
{
public:
	//! constructor with the dim.
	Vertex();
	//! set the point
	void setPoint(float x,float y, float z);
	//! get the x coord
	float getX();
	//! get the y coord
	float getY();
	//! get the z coord
	float getZ();

	//! set the normal
	void setNormal(float x,float y, float z);
	//! get the x Normal coord
	float getNormalX();
	//! get the y Normal coord
	float getNormalY();
	//! get the z Normal coord
	float getNormalZ();

	//! cross product
	Vertex cross(Vertex v2);
	//! the lengt of the vector
	float length();

	//! * operator overloader
	Vertex operator *(float scalar);

private:
	//! The vertex
	float m_vertex[3];
	//! The vertex normal
	float m_normal[3];

};
#endif